#include <iostream>
#include <math.h>
#include <vector>
#include <limits>
#include <gmpxx.h>
#include "hdnum.hh"

using namespace hdnum;

#include "model.hh"
#include "shooting.hh"

int main ()
{
  typedef double Number;        // define a number type

  // *** add Code here ***
  Vector<Number> u_a1(2,0);       // inital value for y0
  Vector<Number> u_a2(2,0);       // inital value for Y0   
  Vector<Number> u_a3(2,0);       // inital value for Y1
  // u_a1[0] = ?; u_a1[1] = ?;
  // ...
  typedef Model<Number> Model;  // Model type
  Model model1(0.,u_a1,0);      // instantiate model for computing y0
  Model model2(0.,u_a2,1);      // instantiate model for computing Y0
  Model model3(0.,u_a3,1);      // instantiate model for computing Y1

  int n = 10000;                // number of steps
  
  Vector<Number> times;           // store time values here
  Vector<Vector<Number> > states; // store states here

  // *** add Code here ***
  DenseMatrix<Number> b_a(2,2);  // parameters defining boundary values
  DenseMatrix<Number> b_b(2,2);
  Vector<Number> g(2);
  // b_a[0][0] = ?, ...
  typedef Shooting<Model> Shooting;
  double a = 0.;
  double b = M_PI;
  Shooting shoot(model1, model2, model3, a, b, n, b_a, b_b, g);
  shoot.solve();
  shoot.output(times, states);
  char name[255] = "output";
  gnuplot(name,times,states); // output model result
 
  return 0;
}
